<?php

/******************************************************************************/
/******************************************************************************/

class PBHelper
{
	/**************************************************************************/
	
	static function removeUIndex(&$data)
	{
		$argument=array_slice(func_get_args(),1);
		
		$data=(array)$data;
		
		foreach($argument as $index)
		{
			if(!is_array($index))
			{
				if(!array_key_exists($index,$data))
					$data[$index]='';
			}
			else
			{
				if(!array_key_exists($index[0],$data))
					$data[$index[0]]=$index[1];				
			}
		}
	}
	
	/**************************************************************************/
	
	static function extractDictionary($data,$labelIndex=0)
	{
		$dictionary=array();
		
		foreach($data as $index=>$value)
		{
			if(is_array($value))
			{
				if(array_key_exists($labelIndex,$value))
					$dictionary[$index]=$value[$labelIndex];
			}
			else $dictionary[$index]=$value;
		}
		
		return($dictionary);
	}
	
	/**************************************************************************/
	
	static function isArray($array,$key,$index=0)
	{
		if($index>=count($key)) return(true);
		
		if(array_key_exists($key[$index],$array))
			return(PBHelper::isArray($array[$key[$index]],$key,++$index));
		
		return(false);
	}
	
	/**************************************************************************/
	
	static function returnIf($value,$testValue,$text='checked')
	{
		if(is_array($value))
		{
			foreach($value as $v)
			{
				if(strcmp($v,$testValue)==0) return($text);
			}
		}
		else 
		{
			if(strcmp($value,$testValue)==0) return($text);
		}
	}
	
	/**************************************************************************/
	
	static function createClassAttribute($class)
	{
		$Validation=new PBValidation();
		
		$class=trim(implode(' ',$class));
		
		return($Validation->isEmpty($class) ? null : ' class="'.$class.'"');
	}
	
	/**************************************************************************/
	
	static function createStyleAttribute($style)
	{
		$ret=null;
		$Validation=new PBValidation();
		
		foreach($style as $index=>$value)
		{
			if($Validation->isEmpty($value)) continue;
			$ret.=$index.':'.$value.';';
		}
		
		return($Validation->isEmpty($ret) ? null : ' style="'.$ret.'"');
	}
	
	/**************************************************************************/
	
	static function createHash($value)
	{
		return(strtoupper(md5($value)));
	}
	
	/**************************************************************************/
	
	static function createId($prefix=null)
	{
		return((is_null($prefix) ? null : $prefix.'_').strtoupper(md5(microtime().rand())));
	}
	
	/**************************************************************************/
	
	static function linkify($text)
    {
		$text=preg_replace("/(^|[\n ])([\w]*?)([\w]*?:\/\/[\w]+[^ \,\"\n\r\t<]*)/is","$1$2<a href=\"$3\" >$3</a>",$text);  
		$text=preg_replace("/(^|[\n ])([\w]*?)((www)\.[^ \,\"\t\n\r<]*)/is","$1$2<a href=\"http://$3\" >$3</a>",$text);
		$text=preg_replace("/(^|[\n ])([\w]*?)((ftp)\.[^ \,\"\t\n\r<]*)/is","$1$2<a href=\"ftp://$3\" >$3</a>",$text);  
        $text=preg_replace("/(^|[\n ])([a-z0-9&\-_\.]+?)@([\w\-]+\.([\w\-\.]+)+)/i","$1<a href=\"mailto:$2@$3\">$2@$3</a>",$text);  
        return($text);  
    }
	
	/**************************************************************************/
	
	static function getValueFromArray($array,$key)
	{
		$data=array();
		foreach($key as $value)
			$data[$value]=$array[$value];
		
		return($data);
	}
	
	/**************************************************************************/
	
	static function getPostMeta($post)
	{
		$id=is_object($post) ? $post->ID : (int)$post;
		return(get_post_meta($id,PLUGIN_PAGE_BUILDER_CONTEXT,true));
	}
		
	/**************************************************************************/
	
	static function getTerm($term,$argument=array())
	{
		$data=get_terms(array($term),$argument);
		
		if(is_wp_error($data)) return(array());

		$result=array();
		foreach($data as $value)
			$result[$value->slug]=$value->name;

		return($result);
	}
	
	/**************************************************************************/
	
	static function setDeafultOption(&$option,$index,$value)
	{
		if(array_key_exists($index,(array)$option)) return;
		$option[$index]=$value;
	}
	
	/**************************************************************************/
	
	static function getFormName($name,$display=true)
	{
		if(!$display) return(PLUGIN_PAGE_BUILDER_CONTEXT.'_'.$name);
		echo PLUGIN_PAGE_BUILDER_CONTEXT.'_'.$name;
	}
	
	/**************************************************************************/
	
	static function checkSavePost($post_id,$name,$action=null)
	{
		if((defined('DOING_AUTOSAVE')) && (DOING_AUTOSAVE)) return(false);

		if(!array_key_exists($name,$_POST)) return(false);
		
		if(!wp_verify_nonce($_POST[$name],$action)) return(false);

		unset($_POST[$name]);
		
		if(!current_user_can('edit_post',$post_id)) return(false);
		
		return(true);
	}
	
	/**************************************************************************/
	
	static function getPOSTOption($prefix=null)
	{
		if(!is_null($prefix)) $prefix='_'.$prefix.'_';
		
		$option=array();
		foreach($_POST as $key=>$value)
		{
			if(preg_match('/^'.PLUGIN_PAGE_BUILDER_CONTEXT.$prefix.'/',$key,$result)) 
			{
				$index=preg_replace('/^'.PLUGIN_PAGE_BUILDER_CONTEXT.'_/','',$key);
				$option[$index]=$value;
			}
		}	
		
		$option=PBHelper::stripslashesPOST($option);
		
		return($option);
	}
	
	/**************************************************************************/
	
	static function formatCode($value)
	{
		$value=preg_replace('/\t/','',$value);
		$value=preg_replace('~[\r\n\r\n]+~','',$value);
		return($value);
	}
	
	/**************************************************************************/
	
	static function stripslashesPOST($value)
	{
		return(stripslashes_deep($value));
	}
	
	/**************************************************************************/
	
	static function isNumericArray($array)
	{
		if(!is_array($array)) return(false);
		return(array_values($array)===$array);
	}
	
	/**************************************************************************/
	
	static function ajaxResponse($response)
	{
        $json=json_encode($response);
		$buffer=ob_get_clean();
		if(ob_get_contents()) ob_end_clean();
		
		echo $json;
		if($response['debug']==1) echo "\n\n".$buffer;
        exit;
	}

	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/

?>