<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentButton extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$Window=new PBWindow();
		
		$this->style=array
		(
			'button'															=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);
		
		$this->script=array
		(
			'button'															=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'PB.Button.js'
			)
		);
		
		$this->buttonSize=array
		(
			'tiny'																=>	array(__('Tiny',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'small'																=>	array(__('Small',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'medium'															=>	array(__('Medium',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'large'																=>	array(__('Large',PLUGIN_PAGE_BUILDER_DOMAIN))
		);
		
		$this->buttonIconPosition=array
		(
			'left'																=>	array(__('Left',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'right'																=>	array(__('Right',PLUGIN_PAGE_BUILDER_DOMAIN))
		);
		
		$this->icon_url=PBComponentData::get($this->getComponentId(),'icon_url');
		$this->icon_path=PBComponentData::get($this->getComponentId(),'icon_path');
		$this->icon_file=PBComponentData::setFile($this->getComponentId(),'icon_file',$this->icon_path);

		$this->component=array
		(
			'name'																=>	__('Button',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays button',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('Button',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'ui'															=>	array
				(
					'panel'														=>	array
					(
						1														=>	array
						(
							'header'											=>	__('General',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						2														=>	array
						(
							'header'											=>	__('Icon',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						3														=>	array
						(
							'header'											=>	__('Styles',PLUGIN_PAGE_BUILDER_DOMAIN)
						)						
					),
					'group'														=>	array
					(
						1														=>	array
						(
							'header'											=>	__('Normal state',PLUGIN_PAGE_BUILDER_DOMAIN),
							'subheader'											=>	__('Styles used in normal (default) state',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						2														=>	array
						(
							'header'											=>	__('Hover state',PLUGIN_PAGE_BUILDER_DOMAIN),
							'subheader'											=>	__('Styles used in hover state',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
					)
				),
				'element'														=>	array
				(
					array
					(
						'id'													=>	'label',
						'ui'													=>	array
						(
							'panel'													=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Label',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Label of the button',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						),
						'shortcode'												=>	array
						(
							'path'												=>	'@content'
						)
					),
					array
					(
						'id'													=>	'src',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('URL',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('URL address of a link',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),
					array
					(
						'id'													=>	'src_target',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('URL target',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=> PBHelper::extractDictionary($Window->linkTarget)
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'_self'
						)
					),
					array
					(
						'id'													=>	'size',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Button size',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->buttonSize)
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'medium'
						)
					),
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space.',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),
					array
					(
						'id'													=>	'icon_enable',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Enable icon',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),
					array
					(
						'id'													=>	'icon',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Icon',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->icon_file)
								)
							)
						)
					),					
					array
					(
						'id'													=>	'icon_position',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Icon position',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->buttonIconPosition)
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'left'
						)
					),					
					array
					(
						'id'													=>	'text_color',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'group'												=>	1,
							'text'												=>	array
							(
								'label'											=>	__('Text color in HEX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'color-picker'
							)
						)
					),
					array
					(
						'id'													=>	'bg_color',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'group'												=>	1,
							'text'												=>	array
							(
								'label'											=>	__('Background color in HEX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'color-picker'
							)
						)
					),						
					array
					(
						'id'													=>	'border_color',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'group'												=>	1,
							'text'												=>	array
							(
								'label'											=>	__('Border color in HEX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'color-picker'
							)
						)
					),						
					array
					(
						'id'													=>	'border_width',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'group'												=>	1,
							'text'												=>	array
							(
								'label'											=>	__('Border width in PX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	'3'
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),					
					array
					(
						'id'													=>	'text_color_hover',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'group'												=>	2,
							'text'												=>	array
							(
								'label'											=>	__('Text color in HEX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'color-picker'
							)
						)
					),
					array
					(
						'id'													=>	'bg_color_hover',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'group'												=>	2,
							'text'												=>	array
							(
								'label'											=>	__('Background color in HEX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'color-picker'
							)
						)
					),						
					array
					(
						'id'													=>	'border_color_hover',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'group'												=>	2,
							'text'												=>	array
							(
								'label'											=>	__('Border color in HEX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'color-picker'
							)
						)
					),						
					array
					(
						'id'													=>	'border_width_hover',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'group'												=>	2,
							'text'												=>	array
							(
								'label'											=>	__('Border width in PX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	'3'
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),	
					
				)
			)
		);	
		
		parent::__construct();
	}
	
	/**************************************************************************/
	
	function createCSS()
	{
		$CSS=new PBCSS();
		
		$code=null;

		foreach($this->icon_file as $value)
		{
			$code.=$CSS->create(array
			(
				'selector'	=>	array
				(
					'.pb-button.pb-button-icon-'.PBHelper::createHash($value).'>a>span.pb-button-box>span.pb-button-icon'
				),
				'property'	=>	array
				(
					'background-image'	=>	$this->icon_url.$value,
				)
			));	
		}
		
		PBComponentData::set($this->getComponentId(),'css',$code);
	}
	
	/**************************************************************************/
	
	function processShortcodeButton($attribute,$content,$tag)
	{
		$attribute=$this->processAttribute($tag,$attribute);

		$Window=new PBWindow();
		$Validation=new PBValidation();
		
		if($Validation->isEmpty($content)) return(null);
		if($Validation->isEmpty($attribute['src'])) return(null);
		if(!in_array($attribute['src_target'],array_keys($Window->linkTarget))) return(null);
		if(!in_array($attribute['size'],array_keys($this->buttonSize))) return(null);
		if(!$Validation->isBool($attribute['icon_enable'])) return(null);
		
		if($attribute['icon_enable']==1)
		{
			if($Validation->isEmpty($attribute['icon'])) return(null);
			if(!in_array($attribute['icon_position'],array_keys($this->buttonIconPosition))) return(null);
		}
		
		if(!$Validation->isHexColor($attribute['text_color'],true)) return(null);
		if(!$Validation->isHexColor($attribute['bg_color'],true)) return(null);
		if(!$Validation->isHexColor($attribute['border_color'],true)) return(null);
		if(!$Validation->isNumber($attribute['border_width'],0,999,true)) return(null);
		
		if(!$Validation->isHexColor($attribute['text_color_hover'],true)) return(null);
		if(!$Validation->isHexColor($attribute['bg_color_hover'],true)) return(null);
		if(!$Validation->isHexColor($attribute['border_color_hover'],true)) return(null);
		if(!$Validation->isNumber($attribute['border_width_hover'],0,999,true)) return(null);		
		
		$class=array();
		
		$class[0]=array('pb-button');
		$class[1]=array($Window->getTargetCSSClass($attribute['src_target']));
		$class[2]=array('pb-button-icon');
		$class[3]=array('pb-button-content');
		
		array_push($class[0],'pb-button-size-'.$attribute['size']);
		
		if($attribute['icon_enable']==1)
		{
			array_push($class[0],'pb-button-icon');
			array_push($class[0],'pb-button-icon-'.PBHelper::createHash($attribute['icon']));
			array_push($class[0],'pb-button-icon-position-'.$attribute['icon_position']);
		}
		
		$class[0][]=$attribute['css_class'];
		
		$style=array();
		$option=array();
		
		if($Validation->isHexColor($attribute['text_color']))
		{
			$style['color']='#'.$attribute['text_color'];
			$option['out']['color']=$style['color'];
		}
		if($Validation->isHexColor($attribute['bg_color']))
		{
			$style['background-color']='#'.$attribute['bg_color'];
			$option['out']['background-color']=$style['background-color'];
		}
		if($Validation->isHexColor($attribute['border_color']))
		{
			$style['border-color']='#'.$attribute['border_color'];
			$option['out']['border-color']=$style['border-color'];
		}
		if($Validation->isNumber($attribute['border_width'],0,999))
		{
			$style['border-style']='solid';
			$option['out']['border-style']=$style['border-style'];
			
			$style['border-width']=$attribute['border_width'].'px';
			$option['out']['border-width']=$style['border-width'];
		}
		
		if($Validation->isHexColor($attribute['text_color_hover']))
			$option['in']['color']='#'.$attribute['text_color_hover'];
		if($Validation->isHexColor($attribute['bg_color_hover']))
			$option['in']['background-color']='#'.$attribute['bg_color_hover'];			
		if($Validation->isHexColor($attribute['border_color_hover']))
			$option['in']['border-color']='#'.$attribute['border_color_hover'];	
		if($Validation->isNumber($attribute['border_width_hover'],0,999))
		{
			$option['in']['border-style']='solid';
			$option['in']['border-width']=$attribute['border_width_hover'].'px';	
		}
		
		$id=PBHelper::createId('pb_button');
		
		$html=
		'
			<div'.PBHelper::createClassAttribute($class[0]).' id="'.$id.'">
				<a href="'.esc_attr($attribute['src']).'"'.PBHelper::createClassAttribute($class[1]).PBHelper::createStyleAttribute($style).'>
					<span class="pb-button-box">
						<span'.PBHelper::createClassAttribute($class[2]).'></span>
						<span'.PBHelper::createClassAttribute($class[3]).'>'.do_shortcode($content).'</span>
					</span>
				</a>
				<div class="pb-script-tag">
					<script type="text/javascript">
						jQuery(document).ready(function($) 
						{
							$(\'#'.$id.'\').PBButton('.json_encode($option).');
						});
					</script>
				</div>
			</div>
		';
		
		return(PBHelper::formatCode($html));
	}
	
	/**************************************************************************/
	
}

/******************************************************************************/
/******************************************************************************/

?>