<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentDivider extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$this->style=array
		(
			'divider'															=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);
		
		$this->borderStyle=array
		(
			'none'																=>	array(__('None',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'hidden'															=>	array(__('Hidden',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'dotted'															=>	array(__('Dotted',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'dashed'															=>	array(__('Dashed',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'solid'																=>	array(__('Solid',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'double'															=>	array(__('Double',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'groove'															=>	array(__('Groove',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'ridge'																=>	array(__('Ridge',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'inset'																=>	array(__('Inset',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'outset'															=>	array(__('Outset',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'inherit'															=>	array(__('Inherit',PLUGIN_PAGE_BUILDER_DOMAIN))
		);
		
		$this->component=array
		(
			'name'																=>	__('Divider',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays divider',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('Divider',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'element'														=>	array
				(
					array
					(
						'id'													=>	'line_height',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Line height',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Line height in PX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	4
								)
							)
						)
					),
					array
					(
						'id'													=>	'line_style',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Line style',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->borderStyle),
								)
							)
						)
					),
					array
					(
						'id'													=>	'line_color',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Line color',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Line color in HEX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'color-picker'
							)
						)
					),	
					array
					(
						'id'													=>	'margin_top',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Top margin',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Top margin in PX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	4
								)
							)
						)
					),
					array
					(
						'id'													=>	'margin_bottom',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Bottom margin',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Bottom margin in PX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	4
								)
							)
						)
					),					
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space.',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),					
				)
			)
		);	
		
		parent::__construct();
	}
	
	/**************************************************************************/

	function processShortcodeDivider($attribute,$content,$tag)
	{
		$attribute=$this->processAttribute($tag,$attribute);
		
		$Validation=new PBValidation();
		
		$style=array();
		
		if($Validation->isNumber($attribute['line_height'],0,9999))
			$style['border-bottom-width']=$attribute['line_height'].'px';
		if($Validation->isHexColor($attribute['line_color']))
			$style['border-color']='#'.$attribute['line_color'];
		if(in_array($attribute['line_style'],array_keys($this->borderStyle)))
			$style['border-style']=$attribute['line_style'];
		if($Validation->isNumber($attribute['margin_top'],0,9999))
			$style['margin-top']=$attribute['margin_top'].'px';
		if($Validation->isNumber($attribute['margin_bottom'],0,9999))
			$style['margin-bottom']=$attribute['margin_bottom'].'px';
		
		$class=array('pb-divider','pb-clear-fix',$attribute['css_class']);
		
		$html=
		'
			<div'.PBHelper::createClassAttribute($class).PBHelper::createStyleAttribute($style).'></div>
		';
		
		return(PBHelper::formatCode($html));
	}
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/

?>