<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentFeature extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$Layout=new PBLayout();
		$Easing=new PBEasing();
		$CarouFredSel=new PBCarouFredSel();
		
		$this->style=array
		(
			'feature'															=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);	
		
		$this->script=array
		(
			'feature'															=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'PB.Feature.js'
			)
		);
		
		$this->icon=(array)PBComponentData::get($this->getComponentId(),'icon');
		
		foreach($this->icon as $index=>$value)
			$this->icon[$index]['file']=PBComponentData::setFile($this->getComponentId(),'icon_feature_'.$index,$value['path']);

		$this->layout=$Layout->getMainLayout();
		
		$this->iconPosition=array
		(	
			'top'																=>	array(__('Top',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'right'																=>	array(__('Right',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'bottom'															=>	array(__('Bottom',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'left'																=>	array(__('Left',PLUGIN_PAGE_BUILDER_DOMAIN))
		);
		
		$this->animation=array
		(
			'none'																=>	array(__('None',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'fadeIn'															=>	array(__('Fade In',PLUGIN_PAGE_BUILDER_DOMAIN))
		);
		
		$this->component=array
		(
			'name'																=>	__('Features',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays Features',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('Features',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'ui'															=>	array
				(
					'panel'														=>	array
					(
						1														=>	array
						(
							'header'											=>	__('General',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						2														=>	array
						(
							'header'											=>	__('Carousel',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						3														=>	array
						(
							'header'											=>	__('Animations',PLUGIN_PAGE_BUILDER_DOMAIN)
						)
					)
				),	
				'element'														=>	array
				(
					array
					(
						'id'													=>	'category',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Category',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select one or more categories from which features have to be retrieved.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'term',
								'dictionary'									=>	array
								(
									'term'										=>	PLUGIN_PAGE_BUILDER_CONTEXT.'_feature_category'
								)
							)
						)
					),
					array
					(
						'id'													=>	'layout',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Layout',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select layout of the fetaures.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->layout,'name')
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'100'
						)
					),					
					array
					(
						'id'													=>	'icon_size',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Icon size',PLUGIN_PAGE_BUILDER_DOMAIN),
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->icon,'label')
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'medium'
						)
					),					
					array
					(
						'id'													=>	'icon_position',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Icon position',PLUGIN_PAGE_BUILDER_DOMAIN),
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=> PBHelper::extractDictionary($this->iconPosition)
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'left'
						)
					),		
					array
					(
						'id'													=>	'limit',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Limit',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Limit the number of features',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	4
								)	
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space.',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),
					array
					(
						'id'													=>	'carousel_enable',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Enable carousel',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable carousel',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	0
						)
					),	
					array
					(
						'id'													=>	'carousel_autoplay_enable',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Autoplay',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Autoplay',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	0
						)
					),						
					array
					(
						'id'													=>	'carousel_circular_enable',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Circular',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the carousel should be circular',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	1
						)
					),						
					array
					(
						'id'													=>	'carousel_infinite_enable',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Infinite',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the carousel should be infinite',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	1
						)
					),
					array
					(
						'id'													=>	'carousel_scroll_pause_hover',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Pause on hover',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the timeout between transitions should be paused',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	1
						)
					),
					array
					(
						'id'													=>	'carousel_scroll_fx',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Scroll effect',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Indicates which effect to use for the transition',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($CarouFredSel->scrollFX)
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'scroll'
						)
					),						
					array
					(
						'id'													=>	'carousel_scroll_easing',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Easing',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Indicates which easing function to use for the transition',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($Easing->easingType)
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'easeInQuad'
						)
					),						
					array
					(
						'id'													=>	'carousel_scroll_duration',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Duration',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines the duration of the transition in milliseconds',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'500'
						)
					),
					array
					(
						'id'													=>	'animation_type',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Animation',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select animation',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->animation),
									'use_default'								=>	false
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'none'
						)
					),
					array
					(
						'id'													=>	'animation_duration',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Duration of animation',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines the duration of the animation in milliseconds',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	5
								)	
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'500'
						)
					),
					array
					(
						'id'													=>	'animation_icon_opacity_start',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Icons opacity',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Initial opacity value of the icons for "fadeIn" animation.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'slider',
								'value'											=>	10,
								'option'										=>	array
								(
									'min'										=>	0,
									'max'										=>	100
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	10
						)
					),	
				)
			)
		);		
		
		parent::__construct();
	}
	
	/**************************************************************************/
	
	function createCSS()
	{
		$CSS=new PBCSS();
		
		$code=null;

		foreach($this->icon as $iconSetIndex=>$iconSetValue)
		{
			foreach($iconSetValue['file'] as $value)
			{
				$code.=$CSS->create(array
				(
					'selector'	=>	array
					(
						'div.pb-feature.pb-feature-icon-size-'.$iconSetIndex.' ul>li>div>.pb-feature-icon-'.PBHelper::createHash($value)
					),
					'property'	=>	array
					(
						'background-image'	=>	$iconSetValue['url'].$value,
					)
				));	
			}
		}
		
		PBComponentData::set($this->getComponentId(),'css',$code);
	}
	
	/**************************************************************************/
	
	function processShortcodeFeature($attribute,$content,$tag)
	{
		global $post;
		
		$attribute=$this->processAttribute($tag,$attribute);
		
		$Layout=new PBLayout();
		$Easing=new PBEasing();
		$Validation=new PBValidation();
		$CarouFredSel=new PBCarouFredSel();
				
		if(!array_key_exists($attribute['layout'],$this->layout)) return(null);
		if(!array_key_exists($attribute['icon_size'],$this->icon)) return(null);
		if(!array_key_exists($attribute['icon_position'],$this->iconPosition)) return(null);
		
		if(!$Validation->isNumber($attribute['limit'],0,9999)) return(null);
		
		if(!$Validation->isBool($attribute['carousel_enable'])) return(null);

		if(!$Validation->isBool($attribute['carousel_autoplay_enable'])) return(null);
		if(!$Validation->isBool($attribute['carousel_circular_enable'])) return(null);
		if(!$Validation->isBool($attribute['carousel_infinite_enable'])) return(null);
		
		if(!$Validation->isBool($attribute['carousel_scroll_pause_hover'])) return(null);

		if(!array_key_exists($attribute['carousel_scroll_fx'],$CarouFredSel->scrollFX)) return(null);
		if(!array_key_exists($attribute['carousel_scroll_easing'],$Easing->easingType)) return(null);
		if(!$Validation->isNumber($attribute['carousel_scroll_duration'],1,99999)) return(null);
	
		if(!array_key_exists($attribute['animation_type'],$this->animation)) return(null);
		if(!$Validation->isNumber($attribute['animation_duration'],1,99999)) return(null);
		if(!$Validation->isNumber($attribute['animation_icon_opacity_start'],0,100)) return(null);

		$data=$this->getFeature($attribute);
		
		if($data===false) return(null);
		if(!count($data->posts)) return(null);
		
		$carouselOption=array();
		$key=array
		(
			'carousel_enable',
			'carousel_autoplay_enable',
			'carousel_circular_enable',
			'carousel_infinite_enable',
			'carousel_scroll_pause_hover',
			'carousel_scroll_fx',
			'carousel_scroll_easing',
			'carousel_scroll_duration'
		);
		foreach($key as $index)
			$carouselOption[$index]=$attribute[$index];
		
		$animationOption=array();
		$key=array
		(
			'animation_type',
			'animation_duration',
			'animation_icon_opacity_start'
		);
		foreach($key as $index)
			$animationOption[$index]=$attribute[$index];
		
		$i=0;
		$html=null;
		
		global $post;
		$bPost=$post;
		
		while($data->have_posts())
		{
			$data->the_post();
			
			$option=PBHelper::getPostMeta($post);
			
			$class=array(array());
		
			$class[0]=array('pb-layout-'.$Layout->getLayoutColumnCSSClass($attribute['layout'],$i));
			$class[1]=array('pb-feature-icon','pb-feature-icon-'.PBHelper::createHash($option['feature_icon']));
			
			$headerLevel=$attribute['icon_size']=='small' ? 5 : 4;
			
			$header='<h'.$headerLevel.' class="pb-feature-header">'.get_the_title().'</h'.$headerLevel.'>';
			if($Validation->isURL($option['feature_url']))
				$header='<h'.$headerLevel.' class="pb-feature-header"><a href="'.esc_attr($option['feature_url']).'">'.get_the_title().'</a></h'.$headerLevel.'>';

			$html.=
			'
				<li'.PBHelper::createClassAttribute($class[0]).'>
					<div>
						'.($attribute['icon_position']!='bottom' ? '<div'.PBHelper::createClassAttribute($class[1]).'></div>' : '').'
						'.$header.'
						<div class="pb-feature-content">'.apply_filters('the_content',do_shortcode(get_the_content())).'</div>	
						'.($attribute['icon_position']=='bottom' ? '<div'.PBHelper::createClassAttribute($class[1]).'></div>' : '').'
					</div>
				</li>
			';
			
			$i++;
		}
		
		wp_reset_query();
		$post=$bPost;
		
		$id=PBHelper::createId('pb_feature');
		
		$class=array
		(
			array
			(
				'pb-feature',
				'pb-feature-icon-size-'.$attribute['icon_size'],
				'pb-feature-icon-position-'.$attribute['icon_position'],
				'pb-clear-fix',
				$attribute['css_class']				
			),
			array
			(
				$Layout->getLayoutCSSClass($attribute['layout']),
				'pb-reset-list',
				'pb-clear-fix'
			)
		);

		$html=
		'
			<div'.PBHelper::createClassAttribute($class[0]).' id="'.$id.'">
				<ul'.PBHelper::createClassAttribute($class[1]).'>
					'.$html.'
				</ul>
				<div class="pb-slider-pagination"></div>
			</div>
			<div class="pb-script-tag">
				<script type="text/javascript">
					jQuery(document).ready(function($) 
					{
						$("#'.$id.'").PBFeature('.json_encode($carouselOption).','.json_encode($animationOption).');
					});
				</script>
			</div>
		';
		
		return(PBHelper::formatCode($html));
	}
	
	/**************************************************************************/
	
	function getFeature($attribute)
	{
		$argument=array
		(
			'post_type'										=>	PLUGIN_PAGE_BUILDER_CONTEXT.'_feature',
			PLUGIN_PAGE_BUILDER_CONTEXT.'_feature_category'	=>	$attribute['category'],
			'posts_per_page'								=>	$attribute['limit']<=0 ? -1 : $attribute['limit'],
			'orderby'										=>	'menu_order',
			'order'											=>	'asc'
		);

		$query=new WP_Query($argument);
		if($query===false) return;
		
		return($query);
	}
	
	/**************************************************************************/
	
	function initCustomPostType()
	{
		add_action('init',array($this,'adminInit')); 
		add_action('save_post',array($this,'adminSaveMetaBox'));
		add_action('add_meta_boxes',array($this,'adminInitMetaBox'));
		add_filter('manage_edit-'.PLUGIN_PAGE_BUILDER_CONTEXT.'_feature_columns',array($this,'adminManageEditColumn')); 
		add_action('manage_'.PLUGIN_PAGE_BUILDER_CONTEXT.'_feature_posts_custom_column',array($this,'adminManageColumn'));
		add_filter('manage_edit-'.PLUGIN_PAGE_BUILDER_CONTEXT.'_feature_sortable_columns',array($this,'adminManageEditSortableColumn'));
	}
	
	/**************************************************************************/
	
	function adminInit()
	{
		register_post_type
		(
			PLUGIN_PAGE_BUILDER_CONTEXT.'_feature',
			array
			(  
				'labels'							=> array
				(
					'name'							=>	__('Feature',PLUGIN_PAGE_BUILDER_DOMAIN),
					'singular_name'					=>	__('Features',PLUGIN_PAGE_BUILDER_DOMAIN),
					'add_new'						=>	__('Add New',PLUGIN_PAGE_BUILDER_DOMAIN),
					'add_new_item'					=>	__('Add New Feature',PLUGIN_PAGE_BUILDER_DOMAIN),
					'edit_item'						=>	__('Edit Feature',PLUGIN_PAGE_BUILDER_DOMAIN),
					'new_item'						=>	__('New Feature',PLUGIN_PAGE_BUILDER_DOMAIN),
					'all_items'						=>	__('All Features',PLUGIN_PAGE_BUILDER_DOMAIN),
					'view_item'						=>	__('View Feature',PLUGIN_PAGE_BUILDER_DOMAIN),
					'search_items'					=>	__('Search Feature',PLUGIN_PAGE_BUILDER_DOMAIN),
					'not_found'						=>	__('No Features found',PLUGIN_PAGE_BUILDER_DOMAIN),
					'not_found_in_trash'			=>	__('No Features found in Trash',PLUGIN_PAGE_BUILDER_DOMAIN), 
					'parent_item_colon'				=>	'',
					'menu_name'						=>	__('Features',PLUGIN_PAGE_BUILDER_DOMAIN)
				), 
				'public'							=>	false,  
				'show_ui'							=>	true,  
				'capability_type'					=>	'post',
				'hierarchical'						=>	false,  
				'rewrite'							=>	false,  
				'supports'							=>	array('title','editor','page-attributes'),
			
			)				
		);  
		
		register_taxonomy
		(
			PLUGIN_PAGE_BUILDER_CONTEXT.'_feature_category',
			array(PLUGIN_PAGE_BUILDER_CONTEXT.'_feature'),
			array
			(
				'label'								=>	__('Categories',PLUGIN_PAGE_BUILDER_DOMAIN),
				'labels'							=>	array
				(
					'name'							=>	__('Features categories',PLUGIN_PAGE_BUILDER_DOMAIN),		 
					'singular_name'					=>	__('Features category',PLUGIN_PAGE_BUILDER_DOMAIN),		 
					'menu_name'						=>	__('Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'all_items'						=>	__('All Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'edit_item'						=>	__('Edit Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'view_item'						=>	__('View Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'update_item'					=>	__('Update Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'add_new_item'					=>	__('Add New Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'new_item_name'					=>	__('New Category Name',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'parent_item'					=>	__('Parent Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'parent_item_colon'				=>	__('Parent Category:',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'search_items'					=>	__('Search Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'popular_items'					=>	__('Popular Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'separate_items_with_commas'	=>	__('Separate categories with commas',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'add_or_remove_items'			=>	__('Add or remove categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'choose_from_most_used'			=>	__('Choose from the most used categories',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'hierarchical' => true
			)
		); 	
	}
	
	/**************************************************************************/
	
	function adminCreateMetaBox()
	{
		global $post;
		
		$Window=new PBWindow();
		
		$data=array();

		$data['option']=PBHelper::getPostMeta($post);
		$data['nonce']=wp_nonce_field('adminSaveMetaBox',PLUGIN_PAGE_BUILDER_CONTEXT.'_feature_noncename',false,false);
		
		$data['dictionary']['icon']=$this->icon['medium']['file'];
		$data['dictionary']['windowTarget']=$Window->linkTarget;

		PBHelper::setDeafultOption($data['option'],'feature_icon',null);
		
		PBHelper::setDeafultOption($data['option'],'feature_url',null);
		PBHelper::setDeafultOption($data['option'],'feature_url_window_target',null);

		$Template=new PBTemplate($data,$this->getTemplateFullPath('meta_box'));
		echo $Template->output();				
	}
	
	/**************************************************************************/
	
	function adminInitMetaBox()
	{
		add_meta_box(PLUGIN_PAGE_BUILDER_CONTEXT.'_feature',__('Options',PLUGIN_PAGE_BUILDER_DOMAIN),array($this,'adminCreateMetaBox'),PLUGIN_PAGE_BUILDER_CONTEXT.'_feature','normal','high');	
	}
	
	/**************************************************************************/
	
	function adminSaveMetaBox($postId)
	{
		if($_POST)
		{
			if(PBHelper::checkSavePost($postId,PLUGIN_PAGE_BUILDER_CONTEXT.'_feature_noncename','adminSaveMetaBox')===false) return(false);
			
			$option=PBHelper::getPOSTOption('feature');
			update_post_meta($postId,PLUGIN_PAGE_BUILDER_CONTEXT,$option);
		}		
	}
	
	/**************************************************************************/
	
	function adminManageEditColumn($column)
	{
		$column=array
		(  
			'cb'			=> '<input type="checkbox"/>',
			'feature'		=> __('Feature',PLUGIN_PAGE_BUILDER_DOMAIN),
			'feature_icon'	=> __('Icon',PLUGIN_PAGE_BUILDER_DOMAIN)   
		);    

		return($column);  		
	}
	
	/**************************************************************************/
	
	function adminManageColumn($column)
	{
		global $post;
		$option=PBHelper::getPostMeta($post);

		PBHelper::removeUIndex($option,'feature_icon');
		
		switch($column)  
		{
			case 'feature':   
				echo '<a href="'.get_edit_post_link($post->ID).'">'.get_the_title($post->ID).'</a>'; 
			break;
			case 'feature_icon':   
				echo '<a href="'.get_edit_post_link($post->ID).'">'.esc_html($option['feature_icon']).'</a>'; 
			break;
		}  
		
		return($column);		
	}
	
	/**************************************************************************/
	
	function adminManageEditSortableColumn($column)
	{
		$column['feature']='title';
		$column['feature_icon']='title';
		return($column);		
	}
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/

?>