<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentGoogleMap extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$this->style=array
		(
			'google-map'														=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);	
		
		$this->script=array
		(
			'google-map'														=>	array
			(
				'use'															=>	2,
				'path'															=>	'//maps.google.com/maps/api/js?sensor=false'
			),
			'pb-google-map'														=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'PB.GoogleMap.js',
				'dependencies'													=>	array('jquery'),
			)
		);

		$this->zoomControlStyle=array
		(
			'DEFAULT'															=>	array(__('Default',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'SMALL'																=>	array(__('Small',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'LARGE'																=>	array(__('Large',PLUGIN_PAGE_BUILDER_DOMAIN))
		);

		$this->mapTypeControlStyle=array
		(
			'DEFAULT'															=>	array(__('Default',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'HORIZONTAL_BAR'													=>	array(__('Horizontal Bar',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'DROPDOWN_MENU'														=>	array(__('Dropdown Menu',PLUGIN_PAGE_BUILDER_DOMAIN))
		);

		$this->position=array
		(
			'TOP_CENTER'														=>	array(__('Top center',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'TOP_LEFT'															=>	array(__('Top left',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'TOP_RIGHT'															=>	array(__('Top right',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'LEFT_TOP'															=>	array(__('Left top',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'RIGHT_TOP'															=>	array(__('Right top',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'LEFT_CENTER'														=>	array(__('Left center',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'RIGHT_CENTER'														=>	array(__('Right center',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'LEFT_BOTTOM'														=>	array(__('Left bottom',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'RIGHT_BOTTOM'														=>	array(__('Right bottom',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'BOTTOM_CENTER'														=>	array(__('Bottom center',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'BOTTOM_LEFT'														=>	array(__('Bottom left',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'BOTTOM_RIGHT'														=>	array(__('Bottom right',PLUGIN_PAGE_BUILDER_DOMAIN))	
		);

		$this->mapTypeId=array
		(
			'ROADMAP'															=>	array(__('Roadmap',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'SATELLITE'															=>	array(__('Satellite',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'HYBRID'															=>	array(__('Hybrid',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'TERRAIN'															=>	array(__('Terrain',PLUGIN_PAGE_BUILDER_DOMAIN))
		);	
		
		$this->component=array
		(
			'name'																=>	__('Google Maps',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays Google Map',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('Google Maps',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'ui'															=>	array
				(
					'panel'														=>	array
					(
						1														=>	array
						(
							'header'											=>	__('General',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						2														=>	array
						(
							'header'											=>	__('Map type',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						3														=>	array
						(
							'header'											=>	__('Zoom',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						4														=>	array
						(
							'header'											=>	__('Pan',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						5														=>	array
						(
							'header'											=>	__('Scale',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						6														=>	array
						(
							'header'											=>	__('Street view',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						7														=>	array
						(
							'header'											=>	__('Styles',PLUGIN_PAGE_BUILDER_DOMAIN)
						)									
					),	
					'group'														=>	array
					(
						1														=>	array
						(
							'header'											=>	__('Point coordinates',PLUGIN_PAGE_BUILDER_DOMAIN),
							'legend'											=>	array(__('Coordinates, in order: latitude, longitude.',PLUGIN_PAGE_BUILDER_DOMAIN),__('You can define coordinates using this tool: <a href="http://www.birdtheme.org/useful/googletool.html">http://www.birdtheme.org/useful/googletool.html</a>',PLUGIN_PAGE_BUILDER_DOMAIN)),
						),
						2														=>	array
						(
							'header'											=>	__('Marker coordinates',PLUGIN_PAGE_BUILDER_DOMAIN),
							'legend'											=>	array(__('Coordinates, in order: latitude, longitude.',PLUGIN_PAGE_BUILDER_DOMAIN),__('You can define coordinates using this tool: <a href="http://www.birdtheme.org/useful/googletool.html">http://www.birdtheme.org/useful/googletool.html</a>',PLUGIN_PAGE_BUILDER_DOMAIN)),
						)
					)
				),
				'element'														=>	array
				(
					array
					(
						'id'													=>	'coordinate_lat',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'group'												=>	1,
							'text'												=>	array
							(
								'label'											=>	__('Latitude',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),
					array
					(
						'id'													=>	'coordinate_lng',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'group'												=>	1,
							'text'												=>	array
							(
								'label'											=>	__('Longtitude',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),	
					array
					(
						'id'													=>	'coordinate_marker_lat',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'group'												=>	2,
							'text'												=>	array
							(
								'label'											=>	__('Latitude',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),
					array
					(
						'id'													=>	'coordinate_marker_lng',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'group'												=>	2,
							'text'												=>	array
							(
								'label'											=>	__('Longtitude',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),	
					array
					(
						'id'													=>	'marker_image_url',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Marker image URL',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'browse-image',
							)							
						)
					),	
					array
					(
						'id'													=>	'width',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Width',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Width of the map (in % of the parent selector).',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'slider',
								'value'											=>	100,
								'option'										=>	array
								(
									'min'										=>	1,
									'max'										=>	100
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'100'
						)
					),	
					array
					(
						'id'													=>	'height',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Height',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Map height in PX',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	4
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'200'
						)
					),
					array
					(
						'id'													=>	'draggable',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Draggable',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines whether the map should be draggable',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),					
					array
					(
						'id'													=>	'scrollwheel',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Scrollwheel',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('If disabled, prevents zooming the map during wheel scrolling',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),						
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),
					array
					(
						'id'													=>	'map_type_id',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Map type',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->mapTypeId),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'ROADMAP'
						)
					),
					array
					(
						'id'													=>	'map_type_control_enable',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Map type control',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable map type control',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),
					array
					(
						'id'													=>	'map_type_control_style',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Map type control style',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->mapTypeControlStyle),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'DEFAULT'
						)
					),
					array
					(
						'id'													=>	'map_type_control_position',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Map type control position',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->position),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'TOP_CENTER'
						)
					),
					array
					(
						'id'													=>	'zoom_control_enable',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Zoom control',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable zoom control.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),
					array
					(
						'id'													=>	'zoom_level',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Zoom level',PLUGIN_PAGE_BUILDER_DOMAIN),
							),
							'element'											=>	array
							(
								'type'											=>	'slider',
								'value'											=>	15,
								'option'										=>	array
								(
									'min'										=>	0,
									'max'										=>	21
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'15'
						)
					),
					array
					(
						'id'													=>	'zoom_control_style',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Zoom control style',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->zoomControlStyle),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'SMALL'
						)
					),
					array
					(
						'id'													=>	'zoom_position',
						'ui'													=>	array
						(
							'panel'												=>	3,
							'text'												=>	array
							(
								'header'										=>	__('Zoom position',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->position),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'RIGHT_TOP'
						)
					),
					array
					(
						'id'													=>	'pan_control_enable',
						'ui'													=>	array
						(
							'panel'												=>	4,
							'text'												=>	array
							(
								'header'										=>	__('Pan control',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable pan control',PLUGIN_PAGE_BUILDER_DOMAIN),
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),
					array
					(
						'id'													=>	'pan_control_position',
						'ui'													=>	array
						(
							'panel'												=>	4,
							'text'												=>	array
							(
								'header'										=>	__('Pan control position',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->position),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'TOP_CENTER'
						)
					),
					array
					(
						'id'													=>	'scale_control_enable',
						'ui'													=>	array
						(
							'panel'												=>	5,
							'text'												=>	array
							(
								'header'										=>	__('Scale control',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable scale control',PLUGIN_PAGE_BUILDER_DOMAIN),
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),
					array
					(
						'id'													=>	'scale_control_position',
						'ui'													=>	array
						(
							'panel'												=>	5,
							'text'												=>	array
							(
								'header'										=>	__('Scale control position',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->position),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'TOP_CENTER'
						)
					),	
					array
					(
						'id'													=>	'street_view_enable',
						'ui'													=>	array
						(
							'panel'												=>	6,
							'text'												=>	array
							(
								'header'										=>	__('Street view',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable street view',PLUGIN_PAGE_BUILDER_DOMAIN),
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),
					array
					(
						'id'													=>	'street_view_position',
						'ui'													=>	array
						(
							'panel'												=>	6,
							'text'												=>	array
							(
								'header'										=>	__('Street view position',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->position),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'TOP_CENTER'
						)
					),	
					array
					(
						'id'													=>	'saturation',
						'ui'													=>	array
						(
							'panel'												=>	7,
							'text'												=>	array
							(
								'header'										=>	__('Saturation',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Saturation of the map.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'slider',
								'option'										=>	array
								(
									'min'										=>	-100,
									'max'										=>	100
								)
							)
						)
					)
				)
			)
		);			
		
		parent::__construct();
	}
		
	/**************************************************************************/
	
	function processShortcodeGoogleMap($attribute,$content,$tag)
	{
		$attribute=$this->processAttribute($tag,$attribute);
	
		$Validation=new PBValidation();

		if($Validation->isEmpty($attribute['coordinate_lat'])) return(null);
		if($Validation->isEmpty($attribute['coordinate_lng'])) return(null);
		if($Validation->isEmpty($attribute['coordinate_marker_lat'])) return(null);
		if($Validation->isEmpty($attribute['coordinate_marker_lng'])) return(null);
		
		if(!$Validation->isNumber($attribute['width'],1,100)) return(null);
		if(!$Validation->isNumber($attribute['height'],1,9999)) return(null);
		
		if(!$Validation->isBool($attribute['draggable'])) return(null);
		if(!$Validation->isBool($attribute['scrollwheel'])) return(null);
		
		if(!array_key_exists($attribute['map_type_id'],$this->mapTypeId)) return(null);
		if(!array_key_exists($attribute['map_type_control_position'],$this->position)) return(null);
		if(!array_key_exists($attribute['map_type_control_style'],$this->mapTypeControlStyle)) return(null);
		if(!$Validation->isBool($attribute['map_type_control_enable'])) return(null);
		
		if(!$Validation->isNumber($attribute['zoom_level'],1,21)) return(null);
		if(!$Validation->isBool($attribute['zoom_control_enable'])) return(null);
		if(!array_key_exists($attribute['zoom_position'],$this->position)) return(null);
		if(!array_key_exists($attribute['zoom_control_style'],$this->zoomControlStyle)) return(null);
		
		if(!$Validation->isBool($attribute['pan_control_enable'])) return(null);
		if(!array_key_exists($attribute['pan_control_position'],$this->position)) return(null);
		
		if(!$Validation->isBool($attribute['scale_control_enable'])) return(null);
		if(!array_key_exists($attribute['scale_control_position'],$this->position)) return(null);
		
		if(!$Validation->isBool($attribute['street_view_enable'])) return(null);
		if(!array_key_exists($attribute['street_view_position'],$this->position)) return(null);
		
		if(!$Validation->isNumber($attribute['saturation'],-100,100)) return(null);
		
		$id=PBHelper::createId('google_map');

		$class=array('pb-google-map',$attribute['css_class']);
		
		$html=
		'
			<div id="'.$id.'"'.PBHelper::createClassAttribute($class).'></div>
			<div class="pb-script-tag">
				<script type="text/javascript">
					jQuery(document).ready(function($)
					{
						$(\'#'.$id.'\').PBGoogleMap('.json_encode($attribute).');
					});
				</script>
			</div>
		';
		
		return($html);
	}
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/

?>