<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentHeader extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$Font=new PBFont();
		
		$this->style=array
		(
			'header'															=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);
		
		$this->headerImportant=array
		(
			'1'																	=>	array(__('H1',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'2'																	=>	array(__('H2',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'3'																	=>	array(__('H3',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'4'																	=>	array(__('H4',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'5'																	=>	array(__('H5',PLUGIN_PAGE_BUILDER_DOMAIN)),
			'6'																	=>	array(__('H6',PLUGIN_PAGE_BUILDER_DOMAIN))
		);
		
		$this->component=array
		(
			'name'																=>	__('Header',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays header',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('Header',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'element'														=>	array
				(
					array
					(
						'id'													=>	'header',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Header',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Content of the header',PLUGIN_PAGE_BUILDER_DOMAIN),
							)
						),
						'shortcode'												=>	array
						(
							'path'												=>	'@content'
						)
					),
					array
					(
						'id'													=>	'important',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Importance of the header',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($this->headerImportant),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'3'
						)
					),
					array
					(
						'id'													=>	'underline_enable',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Underline',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable header underline',PLUGIN_PAGE_BUILDER_DOMAIN),
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2',
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),	
					array
					(
						'id'													=>	'font_size',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Font size',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Font size in PX. Value 0 means that default size for selected header will be used.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'slider',
								'value'											=>	0,
								'option'										=>	array
								(
									'min'										=>	0,
									'max'										=>	200
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'0'
						)
					),	
					array
					(
						'id'													=>	'font_weight',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Font weight',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($Font->weight),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'-1'
						)
					),					
					array
					(
						'id'													=>	'font_style',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Font style',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'radio',
								'dictionary'									=>	array
								(
									'source'									=>	PBHelper::extractDictionary($Font->style),
								)
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'-1'
						)
					),					
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space.',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),					
				)
			)
		);	
		
		parent::__construct();
	}
	
	/**************************************************************************/
	
	function processShortcodeHeader($attribute,$content,$tag)
	{
		$attribute=$this->processAttribute($tag,$attribute);
		
		$Font=new PBFont();
		$Validation=new PBValidation();
		
		if($Validation->isEmpty($content)) return(null);
		
		if(!in_array($attribute['important'],array_keys($this->headerImportant))) return(null);
	
		$style=array();
		if($Validation->isNumber($attribute['font_size'],1,200,true))
			$style['font-size']=$attribute['font_size'].'px';
		if(array_key_exists($attribute['font_weight'],$Font->weight))
			$style['font-weight']=$attribute['font_weight'];
		if(array_key_exists($attribute['font_style'],$Font->style))
			$style['font-style']=$attribute['font_style'];
			
		$class=array('pb-header',$attribute['css_class']);
		
		$html=
		'
			<h'.(int)$attribute['important'].PBHelper::createClassAttribute($class).PBHelper::createStyleAttribute($style).'>
				<span class="pb-header-content">'.do_shortcode($content).'</span>
				'.($attribute['underline_enable']==1 ? '<span class="pb-header-underline"></span>' : null).'
			</h'.(int)$attribute['important'].'>
		';
		
		return(PBHelper::formatCode($html));
	}
	
	/**************************************************************************/
	
}

/******************************************************************************/
/******************************************************************************/

?>