/******************************************************************************/
/******************************************************************************/

;(function($,doc,win) 
{
	"use strict";
	
	var PBImageCarousel=function(object,option)
	{
		/**********************************************************************/
		
		var $this=$(object);
		var $option=option;

		/**********************************************************************/

		this.build=function() 
		{
			var self=this;
			
			var helper=new PBHelper();
			var loadClass=helper.addLoadClass();
			
			if($option.preloader_enable==1)
			{
				$this.preloaderImage(
				{
					animationEnable				:	false,
					onReady						:	function() 
					{
						var height=$this.find('li>div>img').actual('height');

						$this.animate({'height':height},{duration:1000,easing:'easeOutQuint',complete:function() 
						{
							$this.css({'height':'auto'}).removeClass('pb-preloader');
							self.createCarousel(loadClass);
						}});
					}
				});
			}
			else
			{
				var i=0;
				var image=$this.find('li>div>img');
				var imageCount=image.length;
				
				image.each(function() 
				{
					$(this).attr('src',$(this).attr('src')+'?i='+helper.getRandom(1,100000));
					$(this).bind('load',function() 
					{ 
						i++;
						
						$(this).unbind('load');
						
						if(i==imageCount)
						{
							$this.css({'height':'auto'});
							self.createCarousel(loadClass);
						}
					});
				});	
			}
		};
		
		/**********************************************************************/
		
		this.createCarousel=function(loadClass)
		{
			var self=this;
			var carousel=$this.children('ul').first();
			
			if($option.carousel_height_adjust==1)
				self.customizeHeight(carousel);
			
			carousel.carouFredSel(
			{
				auto					:
				{
					play				:	parseInt($option.autoplay_enable)==1 ? true : false,
					delay				:	parseInt($option.delay),
					timeoutDuration		:	parseInt($option.timeout_duration)
				},
				infinite				:	parseInt($option.infinite_enable)==1 ? true : false,
				circular				:	parseInt($option.circular_enable)==1 ? true : false,
				direction				:	$option.direction,
				responsive				:	true,
				items					: 
				{
					height				:	'auto',
					visible				:	1,
					minimum				:	2
				},
				pagination				:	
				{
					anchorBuilder		:	function() 
					{
						var count=$(this).parent('ul').children('li').length;
						return('<a href="#" style="width:'+((100/count)-4)+'%;margin-right:2%;margin-left:2%"></a>');	
					},
					container			:	function() 
					{ 
						return($(this).parents('.pb-image-carousel').find('.pb-slider-pagination')); 
					}
				},		
				scroll: 
				{
					items				:	parseInt($option.scroll_item),
					duration			:	parseInt($option.scroll_duration),
					fx					:	$option.scroll_fx,
					easing				:	$option.scroll_easing,
					pauseOnHover		:	$option.pause_on_hover
				},
				swipe					:				
				{
					onTouch				:	parseInt($option.touch_enable)==1 ? true : false,
					onMouse				:	parseInt($option.mouse_enable)==1 ? true : false
				},
				onCreate				:	function()
				{
					$(window).bind('resize',function() 
					{
						self.zoom();
						
						if($option.carousel_height_adjust==1)
							self.customizeHeight(carousel);
						
						carousel.trigger('updateSizes');
					});
					
					self.zoom();
					
					$(window).trigger('resize');
					
					var helper=new PBHelper();
					helper.removeLoadClass(loadClass);
				}				
			});
		};
		
		/**********************************************************************/

		this.customizeHeight=function(carousel)
		{
			var windowHeight=$(window).height();
			var imageHeight=carousel.find('img').actual('height');

			if((imageHeight<windowHeight) || (windowHeight<600))
			{
				carousel.find('li').height('auto');
				carousel.find('li>div').height('auto');
			}
			else
			{
				carousel.find('li').height(windowHeight);
				carousel.find('li>div').height(windowHeight);
			}
		};
		
		/**********************************************************************/
		
		this.zoom=function()
		{
			var width=parseInt($this.find('.pb-main:first').actual('width'));
			
			var zoom=width/960;

			var headerFontSize=Math.floor($option.header_font_size*zoom);
			var subheaderFontSize=Math.floor($option.subheader_font_size*zoom);

			headerFontSize=headerFontSize<11 ? 11 : headerFontSize;
			subheaderFontSize=subheaderFontSize<11 ? 11 : subheaderFontSize;

			$this.find('.pb-image-carousel-box-header').css('font-size',headerFontSize);
			$this.find('.pb-image-carousel-box-subheader').css('font-size',subheaderFontSize);
		};
		
		/**********************************************************************/
	};
	
	/**************************************************************************/
	
	$.fn.PBImageCarousel=function(option) 
	{
		var slider=new PBImageCarousel(this,option);
		slider.build();
	};
	
	/**************************************************************************/

})(jQuery,document,window);