<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentList extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$this->bullet=array();
		
		$bullet=(array)PBComponentData::get($this->getComponentId(),'bullet');
		foreach($bullet as $index=>$value)
		{
			$this->bullet[$index]['url']=$value['url'];
			$this->bullet[$index]['path']=$value['path'];
			$this->bullet[$index]['css_class']=$value['css_class'];
			
			$file=PBFile::scanDir($value['path']);
			
			$this->bullet[$index]['file']=array();
			if(is_array($file)) $this->bullet[$index]['file']=array_combine($file,$file);
		}

		$this->style=array
		(
			'list'																=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);	
		
		$this->component=array
		(
			'name'																=>	__('List',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays list',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('List',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'element'														=>	array
				(
					array
					(
						'id'													=>	'bullet',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('Bullet',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select bullet of the list element',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'select-one',
								'dictionary'									=>	array
								(
									'source'									=>	(array_key_exists('default',$this->bullet) ? $this->bullet['default']['file'] : array())
								)
							)
						)
					),
					array
					(
						'id'													=>	'list',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('List',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Content of the list',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'editor'
							)
						),
						'visibility'											=>	1,
						'shortcode'												=>	array
						(
							'path'												=>	'@content'
						)
					),					
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space.',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),					
				)
			)
		);	

		parent::__construct();
	}
	
	/**************************************************************************/
	
	function createCSS()
	{
		$CSS=new PBCSS();
		
		$code=null;

		foreach($this->bullet as $value)
		{
			foreach((array)$value['file'] as $file)
			{
				$code.=$CSS->create(array
				(
					'selector'	=>	array
					(
						$value['css_class'].' div.pb-list.pb-list-'.PBHelper::createHash($file).' ul li'
					),
					'property'	=>	array
					(
						'background-image'	=>	$value['url'].$file,
					)
				));		
			}
		}
		
		PBComponentData::set($this->getComponentId(),'css',$code);
	}

	/**************************************************************************/
	
	function processShortcodeList($attribute,$content,$tag)
	{
		$attribute=$this->processAttribute($tag,$attribute);
		
		$Validation=new PBValidation();
		
		$classBullet=null;
		if($Validation->isNotEmpty($attribute['bullet']))
			$classBullet='pb-list-'.PBHelper::createHash($attribute['bullet']);
		
		$class=array('pb-list',$classBullet,$attribute['css_class']);

		$html=
		'
			<div'.PBHelper::createClassAttribute($class).'>
				'.apply_filters('the_content',do_shortcode($content)).'
			</div>
		';
		
		return(PBHelper::formatCode($html));
	}
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/

?>