<?php

/******************************************************************************/
/******************************************************************************/

class PBComponentTeam extends PBComponent
{
	/**************************************************************************/

	function __construct()
	{
		$this->social=array();
		
		$this->social_icon_url=PBComponentData::get($this->getComponentId(),'social_icon_url');
		$this->social_icon_path=PBComponentData::get($this->getComponentId(),'social_icon_path');
		$this->social_icon_file=PBComponentData::setFile($this->getComponentId(),'social_icon_file',$this->social_icon_path);
		
		foreach($this->social_icon_file as $value)
		{
			$pathinfo=pathinfo($this->social_icon_path.$value);
			
			$id=$pathinfo['filename'];
			$name=ucfirst(preg_replace(array('/-/','/_/'),' ',$pathinfo['filename']));
			
			$this->social[$id]=array($name,$value);
		}
		
		$this->style=array
		(
			'team'																=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getStyleURL(),
				'file'															=>	'style.css'
			)
		);	
		
		$this->script=array
		(
			'team'																=>	array
			(
				'use'															=>	2,
				'path'															=>	$this->getScriptURL(),
				'file'															=>	'PB.Team.js'
			)
		);

		$this->component=array
		(
			'name'																=>	__('Team',PLUGIN_PAGE_BUILDER_DOMAIN),
			'description'														=>	__('Displays Team',PLUGIN_PAGE_BUILDER_DOMAIN),
			'structure'															=>	array
			(
				'window'														=>	array
				(
					'title'														=>	__('Team',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'ui'															=>	array
				(
					'panel'														=>	array
					(
						1														=>	array
						(
							'header'											=>	__('General',PLUGIN_PAGE_BUILDER_DOMAIN)
						),
						2														=>	array
						(
							'header'											=>	__('Animations',PLUGIN_PAGE_BUILDER_DOMAIN)
						)
					)
				),	
				'element'														=>	array
				(
					array
					(
						'id'													=>	'category',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Category',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Select one or more categories from which team members have to be retrieved.',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'term',
								'dictionary'									=>	array
								(
									'term'										=>	PLUGIN_PAGE_BUILDER_CONTEXT.'_team_category'
								)
							)
						)
					),	
					array
					(
						'id'													=>	'preloader_enable',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Preloader',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable preloader on images',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),
					array
					(
						'id'													=>	'hover_enable',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('Hover',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Enable or disable hover on images',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'1'
						)
					),
					array
					(
						'id'													=>	'css_class',
						'ui'													=>	array
						(
							'panel'												=>	1,
							'text'												=>	array
							(
								'header'										=>	__('CSS class',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('List of CSS classes defined in CSS files separated by space.',PLUGIN_PAGE_BUILDER_DOMAIN)
							)
						)
					),
					array
					(
						'id'													=>	'animation_progress_bar_start_enable',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Progress bar animation',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Run progress bar on start',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'type'											=>	'choice-2'
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	1
						)
					),
					array
					(
						'id'													=>	'animation_progress_bar_start_duration',
						'ui'													=>	array
						(
							'panel'												=>	2,
							'text'												=>	array
							(
								'header'										=>	__('Duration of progress bar animation',PLUGIN_PAGE_BUILDER_DOMAIN),
								'subheader'										=>	__('Determines the duration of the animation in milliseconds',PLUGIN_PAGE_BUILDER_DOMAIN)
							),
							'element'											=>	array
							(
								'attribute'										=>	array
								(
									'maxlength'									=>	5
								)	
							)
						),
						'shortcode'												=>	array
						(
							'default'											=>	'500'
						)
					)
				)
			)
		);		
		
		parent::__construct();
	}
	
	/**************************************************************************/
	
	function createCSS()
	{
		$CSS=new PBCSS();
		
		$code=null;
		
		foreach($this->social as $index=>$value)
		{
			$code.=$CSS->create(array
			(
				'selector'	=>	array
				(
					'.pb-team>ul>li ul.pb-team-social-icon-box>li>a.pb-team-social-icon-'.$index
				),
				'property'	=>	array
				(
					'background-image'	=>	PBComponentData::get($this->getComponentId(),'social_icon_url').$value[1],
				)
			));			
		}
		
		PBComponentData::set($this->getComponentId(),'css',$code);
	}
	
	/**************************************************************************/
	
	function processShortcodeTeam($attribute,$content,$tag)
	{
		$html=null;
		$teamHTML=null;
		$option=array();
		
		$attribute=$this->processAttribute($tag,$attribute);
		
		$Layout=new PBLayout();
		$Validation=new PBValidation();
		
		$data=$this->getTeam($attribute);
		
		if($data===false) return;
		if(!count($data->posts)) return;
		
		if(!$Validation->isBool($attribute['hover_enable'])) return;
		if(!$Validation->isBool($attribute['preloader_enable'])) return;
		
		if(!$Validation->isBool($attribute['animation_progress_bar_start_enable'])) return;
		if(!$Validation->isNumber($attribute['animation_progress_bar_start_duration'],1,99999)) return(null);
		
		$key=array
		(
			'hover_enable',
			'preloader_enable',
			'animation_progress_bar_start_enable',
			'animation_progress_bar_start_duration'
		);
		
		foreach($key as $index)
			$option[$index]=$attribute[$index];		
		
		global $post;
		$bPost=$post;
		
		$i=0;
		while($data->have_posts())
		{
			global $post;
			
			$data->the_post();
			
			$full=wp_get_attachment_image_src(get_post_thumbnail_id(),'full');
			$thumbnail=wp_get_attachment_image_src(get_post_thumbnail_id(),'image-480-384');
			
			if(($full==false) || ($thumbnail==false)) continue; 
			
			$meta=PBHelper::getPostMeta($post);
			
			$class=array(array(),array());
			
			$class[0]=array('pb-layout-'.$Layout->getLayoutColumnCSSClass('100',$i));
			
			if($attribute['preloader_enable']==1)
			{
				array_push($class[1],'pb-preloader-image');
			}
			
			/***/
			
			$textHTML=null;
			if(($Validation->isNotEmpty($meta['team_first_name'])) || ($Validation->isNotEmpty($meta['team_second_name'])))
				$textHTML.='<h3 class="pb-team-text-box-member-name">'.trim($meta['team_first_name'].' '.$meta['team_second_name']).'</h3>';
			if($Validation->isNotEmpty($meta['team_position']))
				$textHTML.='<div class="pb-team-text-box-member-position">'.$meta['team_position'].'</div>';
			
			/***/
			
			$socialHTML=null;
			if(is_array($meta['team_social']))
			{
				$social=$meta['team_social'];
				
				$order=array();
				foreach($social as $index=>$value)
					$order[]=$value['team_social_order'];

				array_multisort($social,SORT_ASC,SORT_REGULAR,$order,SORT_ASC,SORT_NUMERIC);
				
				foreach($social as $index=>$value)
				{
					if(!array_key_exists($value['team_social_name'],$this->social)) continue;
					
					$socialHTML.=
					'
						<li>
							<a href="'.esc_attr($value['team_social_url']).'" class="pb-team-social-icon-'.$value['team_social_name'].'"></a>
						</li>
					';
				}
				
				if($Validation->isNotEmpty($socialHTML))
				{
					$socialHTML=
					'
						<ul class="pb-team-social-icon-box pb-reset-list pb-clear-fix">
							'.$socialHTML.'
						</ul>
					';
				}
			}
			
			/***/
			
			$skillHTML=null;
			if(is_array($meta['team_skill']))
			{
				$skill=$meta['team_skill'];

				$order=array();
				foreach($skill as $index=>$value)
					$order[]=$value['team_skill_order'];

				array_multisort($skill,SORT_ASC,SORT_REGULAR,$order,SORT_ASC,SORT_NUMERIC);
				
				foreach($skill as $index=>$value)
				{	
					$skillHTML.=
					'
						<div class="pb-team-skill">
							'.($Validation->isNotEmpty($value['team_skill_name']) ? '<div>'.$value['team_skill_name'].'<span class="pb-team-skill-value">'.(int)$value['team_skill_level'].'%</span></div>' : null).'
							<div class="pb-team-progress-bar value-'.(int)$value['team_skill_level'].'">
								<div class="pb-team-progress-bar-background"></div>
								<div class="pb-team-progress-bar-foreground" style="width:'.(int)$value['team_skill_level'].'%"></div>
							</div>	
						</div>
					';
				}
				
				if($Validation->isNotEmpty($skillHTML))
				{
					$skillHTML=
					'
						<div class="pb-team-skill-box">
							'.$skillHTML.'
						</div>
					';
				}
			}
			
			/***/
			
			$captionHTML=null;
			if(($Validation->isNotEmpty($meta['team_first_name'])) || ($Validation->isNotEmpty($meta['team_second_name'])))
				$captionHTML.='<div class="pb-team-image-caption-member-name">'.trim($meta['team_first_name'].' '.$meta['team_second_name']).'</div>';
			if($Validation->isNotEmpty($meta['team_position']))
				$captionHTML.='<div class="pb-team-image-caption-member-position">'.$meta['team_position'].'</div>';
			
			if($Validation->isNotEmpty($captionHTML))
			{
				$captionHTML=
				'
					<div class="pb-team-image-caption">
						'.$captionHTML.'
					</div>
				';
			}
			
			$teamHTML.=
			'
				<li'.PBHelper::createClassAttribute($class[0]).'>
					<div class="pb-layout-33x66">
						<div class="pb-layout-column-left">
							<div class="pb-team-image-box">
								<a href="'.$full[0].'"'.PBHelper::createClassAttribute($class[1]).'>
									<img src="'.$thumbnail[0].'" alt=""/>
									<span><span></span></span>
								</a>
								'.$captionHTML.'
							</div>
							'.$socialHTML.'
						</div>
						<div class="pb-layout-column-right">
							<div class="pb-team-text-box">
								'.$textHTML.'
								'.apply_filters('the_content',do_shortcode(get_the_content())).'
							</div>
							'.$skillHTML.'
						</div>
					</div>
				</li>
			';
			
			$i++;
		}
		
		wp_reset_query();
		$post=$bPost;
		
		if($Validation->isEmpty($teamHTML)) return;
		
		$id=PBHelper::createId('pb_team');
		
		$class=array();
		
		$class[0]=array('pb-team','pb-clear-fix',$attribute['css_class']);
		$class[1]=array($Layout->getLayoutCSSClass('100'),'pb-reset-list','pb-clear-fix');

		$html=
		'
			<div'.PBHelper::createClassAttribute($class[0]).' id="'.$id.'">
				<ul'.PBHelper::createClassAttribute($class[1]).'>
					'.$teamHTML.'
				</ul>			
			</div>
			<div class="pb-script-tag">
				<script type="text/javascript">
					jQuery(document).ready(function($)
					{
						$(\'#'.$id.'\').PBTeam('.json_encode($option).');
					});
				</script>
			</div>
		';
		
		return(PBHelper::formatCode($html));
	}

	/**************************************************************************/
	
	function getTeam($attribute)
	{
		$argument=array
		(
			'post_type'									=>	PLUGIN_PAGE_BUILDER_CONTEXT.'_team',
			PLUGIN_PAGE_BUILDER_CONTEXT.'_team_category'		=>	$attribute['category'],
			'posts_per_page'							=>	-1,
			'orderby'									=>	'menu_order',
			'order'										=>	'asc'
		);
		
		$query=new WP_Query($argument);
		if($query===false) return;
		
		return($query);
	}
	
	/**************************************************************************/
	
	function initCustomPostType()
	{
		add_action('init',array($this,'adminInit')); 
		add_action('save_post',array($this,'adminSaveMetaBox'));
		add_action('add_meta_boxes',array($this,'adminInitMetaBox'));
		add_filter('manage_edit-'.PLUGIN_PAGE_BUILDER_CONTEXT.'_team_columns',array($this,'adminManageEditColumn')); 
		add_action('manage_'.PLUGIN_PAGE_BUILDER_CONTEXT.'_team_posts_custom_column',array($this,'adminManageColumn'));
		add_filter('manage_edit-'.PLUGIN_PAGE_BUILDER_CONTEXT.'_team_sortable_columns',array($this,'adminManageEditSortableColumn'));
	}
	
	/**************************************************************************/
	
	function adminInit()
	{
		register_post_type
		(
			PLUGIN_PAGE_BUILDER_CONTEXT.'_team',
			array
			(  
				'labels'							=> array
				(
					'name'							=>	__('Team',PLUGIN_PAGE_BUILDER_DOMAIN),
					'singular_name'					=>	__('Team',PLUGIN_PAGE_BUILDER_DOMAIN),
					'add_new'						=>	__('Add New',PLUGIN_PAGE_BUILDER_DOMAIN),
					'add_new_item'					=>	__('Add New Team Member',PLUGIN_PAGE_BUILDER_DOMAIN),
					'edit_item'						=>	__('Edit Team Member',PLUGIN_PAGE_BUILDER_DOMAIN),
					'new_item'						=>	__('New Team Member',PLUGIN_PAGE_BUILDER_DOMAIN),
					'all_items'						=>	__('All Team Members',PLUGIN_PAGE_BUILDER_DOMAIN),
					'view_item'						=>	__('View Team Member',PLUGIN_PAGE_BUILDER_DOMAIN),
					'search_items'					=>	__('Search Team Members',PLUGIN_PAGE_BUILDER_DOMAIN),
					'not_found'						=>	__('No Team Members found',PLUGIN_PAGE_BUILDER_DOMAIN),
					'not_found_in_trash'			=>	__('No Team Members found in Trash',PLUGIN_PAGE_BUILDER_DOMAIN), 
					'parent_item_colon'				=>	'',
					'menu_name'						=>	__('Team',PLUGIN_PAGE_BUILDER_DOMAIN)
				), 
				'public'							=>	false,  
				'show_ui'							=>	true,  
				'capability_type'					=>	'post',
				'hierarchical'						=>	false,  
				'rewrite'							=>	false,  
				'supports'							=>	array('title','editor','page-attributes','thumbnail'),
			
			)				
		);  
		
		register_taxonomy
		(
			PLUGIN_PAGE_BUILDER_CONTEXT.'_team_category',
			array(PLUGIN_PAGE_BUILDER_CONTEXT.'_team'),
			array
			(
				'label'								=>	__('Categories',PLUGIN_PAGE_BUILDER_DOMAIN),
				'labels'							=>	array
				(
					'name'							=>	__('Team categories',PLUGIN_PAGE_BUILDER_DOMAIN),		 
					'singular_name'					=>	__('Team category',PLUGIN_PAGE_BUILDER_DOMAIN),		 
					'menu_name'						=>	__('Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'all_items'						=>	__('All Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'edit_item'						=>	__('Edit Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'view_item'						=>	__('View Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'update_item'					=>	__('Update Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'add_new_item'					=>	__('Add New Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'new_item_name'					=>	__('New Category Name',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'parent_item'					=>	__('Parent Category',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'parent_item_colon'				=>	__('Parent Category:',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'search_items'					=>	__('Search Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'popular_items'					=>	__('Popular Categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'separate_items_with_commas'	=>	__('Separate categories with commas',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'add_or_remove_items'			=>	__('Add or remove categories',PLUGIN_PAGE_BUILDER_DOMAIN),	
					'choose_from_most_used'			=>	__('Choose from the most used categories',PLUGIN_PAGE_BUILDER_DOMAIN)
				),
				'hierarchical' => true
			)
		); 	
	}
	
	/**************************************************************************/
	
	function adminCreateMetaBoxBase()
	{
		global $post;
		
		$data=array();

		$data['option']=PBHelper::getPostMeta($post);
		$data['nonce']=wp_nonce_field('adminSaveMetaBox',PLUGIN_PAGE_BUILDER_CONTEXT.'_team_noncename',false,false);
		
		PBHelper::setDeafultOption($data['option'],'team_first_name',null);
		PBHelper::setDeafultOption($data['option'],'team_second_name',null);
		PBHelper::setDeafultOption($data['option'],'team_position',null);

		$Template=new PBTemplate($data,$this->getTemplateFullPath('meta_box_base'));
		echo $Template->output();				
	}
	
	/**************************************************************************/
	
	function adminCreateMetaBoxSkill()
	{
		global $post;
		
		$data=array();

		$data['option']=PBHelper::getPostMeta($post);
		$data['nonce']=wp_nonce_field('adminSaveMetaBox',PLUGIN_PAGE_BUILDER_CONTEXT.'_team_noncename',false,false);
		
		$data['tableId']=PBHelper::createId('team_skill_table');
		
		PBHelper::setDeafultOption($data['option'],'team_skill','');

		$Template=new PBTemplate($data,$this->getTemplateFullPath('meta_box_skill'));
		echo $Template->output();				
	}
	
	/**************************************************************************/
	
	function adminCreateMetaBoxSocial()
	{
		global $post;
		
		$data=array();

		$data['option']=PBHelper::getPostMeta($post);
		$data['nonce']=wp_nonce_field('adminSaveMetaBox',PLUGIN_PAGE_BUILDER_CONTEXT.'_team_noncename',false,false);
		
		$data['dictionary']['social']=$this->social;
		
		$data['tableId']=PBHelper::createId('team_social_table');
		
		PBHelper::setDeafultOption($data['option'],'team_social','');

		$Template=new PBTemplate($data,$this->getTemplateFullPath('meta_box_social'));
		echo $Template->output();				
	}
	
	/**************************************************************************/
	
	function adminInitMetaBox()
	{
		add_meta_box(PLUGIN_PAGE_BUILDER_CONTEXT.'_team_base',__('Base information',PLUGIN_PAGE_BUILDER_DOMAIN),array($this,'adminCreateMetaBoxBase'),PLUGIN_PAGE_BUILDER_CONTEXT.'_team','normal','high');	
		add_meta_box(PLUGIN_PAGE_BUILDER_CONTEXT.'_team_skill',__('Skills',PLUGIN_PAGE_BUILDER_DOMAIN),array($this,'adminCreateMetaBoxSkill'),PLUGIN_PAGE_BUILDER_CONTEXT.'_team','normal','high');	
		add_meta_box(PLUGIN_PAGE_BUILDER_CONTEXT.'_team_social',__('Social networks',PLUGIN_PAGE_BUILDER_DOMAIN),array($this,'adminCreateMetaBoxSocial'),PLUGIN_PAGE_BUILDER_CONTEXT.'_team','normal','high');	
	}
	
	/**************************************************************************/
	
	function adminSaveMetaBox($postId)
	{
		if($_POST)
		{
			if(PBHelper::checkSavePost($postId,PLUGIN_PAGE_BUILDER_CONTEXT.'_team_noncename','adminSaveMetaBox')===false) return(false);
			
			$option=PBHelper::getPOSTOption('team');
			
			$Validation=new PBValidation();
			
			/***/
			
			PBHelper::removeUIndex($option,'team_skill_name','team_skill_level','team_skill_order');	
			$skill=array
			(
				'team_skill_name'		=>	$option['team_skill_name'],
				'team_skill_level'		=>	$option['team_skill_level'],
				'team_skill_order'		=>	$option['team_skill_order'],
				
			);
			
			unset($option['team_skill_name'],$option['team_skill_level'],$option['team_skill_order']);
			
			foreach($skill['team_skill_name'] as $index=>$value)
			{
				if($Validation->isEmpty($value)) continue;
				
				if(!array_key_exists($index,$skill['team_skill_level'])) continue;
				if(!$Validation->isNumber($skill['team_skill_level'][$index],1,100)) continue;
				
				$option['team_skill'][]=array
				(
					'team_skill_name'		=>	$value,
					'team_skill_level'		=>	$skill['team_skill_level'][$index],
					'team_skill_order'		=>	array_key_exists($index,$skill['team_skill_order']) ? $skill['team_skill_order'][$index] : 0
				);
			}
			
			/***/
			
			PBHelper::removeUIndex($option,'team_social_name','team_social_url','team_social_order');	
			$social=array
			(
				'team_social_name'		=>	$option['team_social_name'],
				'team_social_url'		=>	$option['team_social_url'],
				'team_social_order'		=>	$option['team_social_order'],
			);
			
			unset($option['team_social_name'],$option['team_social_url'],$option['team_social_order']);
			
			foreach($social['team_social_name'] as $index=>$value)
			{
				if(!array_key_exists($value,$this->social)) continue;
				
				if(!array_key_exists($index,$social['team_social_url'])) continue;
				if(!$Validation->isURL($social['team_social_url'][$index])) continue;
				
				$option['team_social'][]=array
				(
					'team_social_name'		=>	$value,
					'team_social_url'		=>	$social['team_social_url'][$index],
					'team_social_order'		=>	array_key_exists($index,$social['team_social_order']) ? $social['team_social_order'][$index] : 0
				);
			}

			update_post_meta($postId,PLUGIN_PAGE_BUILDER_CONTEXT,$option);
		}		
	}
	
	/**************************************************************************/
	
	function adminManageEditColumn($column)
	{
		$column=array
		(  
			'cb'				=> '<input type="checkbox"/>',
			'team_image'		=> __('Image',PLUGIN_PAGE_BUILDER_DOMAIN),
			'team_name'			=> __('Name',PLUGIN_PAGE_BUILDER_DOMAIN),
			
		);    

		return($column);  		
	}
	
	/**************************************************************************/
	
	function adminManageColumn($column)
	{
		global $post;
		$option=PBHelper::getPostMeta($post);
		
		PBHelper::removeUIndex($option,'team_first_name','team_second_name');
		
		switch($column)  
		{
			case 'team_image':   
				
				if(has_post_thumbnail($post->ID))
				{
					echo '<a href="'.get_edit_post_link($post->ID).'">'.get_the_post_thumbnail($post->ID,'thumbnail').'</a><br/>'; 
				}
				
			break;
			case 'team_name':   
	
				echo '<a href="'.get_edit_post_link($post->ID).'">'.trim($option['team_first_name'].' '.$option['team_second_name']).'</a><br/>'; 
	
			break;
		}  
		
		return($column);		
	}
	
	/**************************************************************************/
	
	function adminManageEditSortableColumn($column)
	{
		$column['team_image']='title';
		$column['team_name']='title';
		
		return($column);		
	}
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/

?>