/******************************************************************************/
/******************************************************************************/

;(function($,doc,win) 
{
	"use strict";
	
	var PBTeam=function(object,option)
	{
		/**********************************************************************/
		
		var $this=$(object);
		var $option=option;

		/**********************************************************************/

		this.build=function() 
		{
			var self=this;
			if($option.preloader_enable==1)
			{
				$this.preloaderImage(
				{
					onReady						:	function() 					
					{
						self.createHover();
						self.createFancybox();					
					}
				});
			}
			
			if($option.animation_progress_bar_start_enable==1)
				this.animate();
		};
		
		/**********************************************************************/
		
		this.animate=function()
		{
			var helper=new PBHelper();
			
			var self=this;
			
			$this.find('.pb-team-skill-value').html();
			$this.find('.pb-team-progress-bar>.pb-team-progress-bar-foreground').css({'width':'0'});
			
			$this.find('.pb-team-progress-bar').waypoint(function()
			{
				if(!helper.isAnimationComplete($(this)))
				{
					helper.setAnimationAsComplete($(this));
					
					var object=$(this);

					var max=helper.getValueFromClass(object,'value-');
					
					var labelValue=$(this).prev('div').children('.pb-team-skill-value');

					object.find('.pb-team-progress-bar-foreground').animate({'width':max+'%'},{duration:parseInt($option.animation_progress_bar_start_duration),easing:'linear',step:function(now,fx) 
					{
						if(labelValue.length==1) labelValue.html(parseInt(now)+'%');
					}});
				}
			},
			{
				offset	:	'90%'
			});		
		};
		
		/**********************************************************************/
		
		this.createFancybox=function()
		{
			$this.find('.pb-team-image-box>a').fancyBoxLaunch();
		};
		
		/**********************************************************************/
		
		this.createHover=function()
		{
			if($option.hover_enable!=1) return;
			$this.find('.pb-team-image-box').hoverImage();
		};
		
		/**********************************************************************/
	}
	
	/**************************************************************************/
	
	$.fn.PBTeam=function(option) 
	{
		var object=new PBTeam(this,option);
		object.build();
	};
	
	/**************************************************************************/

})(jQuery,document,window);

/******************************************************************************/
/******************************************************************************/